package com.example.pschmitt.starterapp;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.text.method.ScrollingMovementMethod;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import no.tellu.findit.client.api.AsyncService;

public class ActionChoosingActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_action_choosing);
        //Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        //setSupportActionBar(toolbar);

		AsyncService smartPlatform = ((StarterApp)getApplication()).getSmartPlatformService();
		final String token = smartPlatform.getServiceSpec().getAuthenticationToken();

        //TextView
        TextView textView = (TextView) findViewById(R.id.textView3);

        textView.setMovementMethod(new ScrollingMovementMethod());

        textView.setText("Token: " + token);


        //Fetch Buttons
		Button btnPrefs = (Button) findViewById(R.id.btnprefs);
		Button btnListRes = (Button) findViewById(R.id.btnlistres);
        Button btnAddRes = (Button) findViewById(R.id.btnaddres);
        Button btnDeleteRes = (Button) findViewById(R.id.btndeleteres);
        Button btnFetchRes = (Button) findViewById(R.id.btnfetchres);
		Button btnObserv = (Button) findViewById(R.id.btnobserv);

        //Set onClickListener

		btnPrefs.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				Intent nextScreen = new Intent(ActionChoosingActivity.this, PreferencesActivity.class);
				startActivity(nextScreen);
			}
		});

        btnListRes.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent nextScreen = new Intent(ActionChoosingActivity.this,ListResourcesActivity.class);

                nextScreen.putExtra("token",token);

                startActivity(nextScreen);
            }
        });

        btnAddRes.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent nextScreen = new Intent(ActionChoosingActivity.this,AddResourceActivity.class);

                nextScreen.putExtra("token",token);

                startActivity(nextScreen);
            }
        });

        btnDeleteRes.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent nextScreen = new Intent(ActionChoosingActivity.this,PrepairDeletingActivity.class);

                nextScreen.putExtra("token",token);

                startActivity(nextScreen);
            }
        });

        btnFetchRes.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent nextScreen = new Intent(ActionChoosingActivity.this,FetchResourceActivity.class);

                nextScreen.putExtra("token",token);

                startActivity(nextScreen);
            }
        });

		btnObserv.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				Intent nextScreen = new Intent(ActionChoosingActivity.this, ObservationActivity.class);
				startActivity(nextScreen);
			}
		});
    }


}
