package com.example.pschmitt.starterapp;

//import java.awt.image.BufferedImage;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;

import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;


//import javax.imageio.ImageIO;
import javax.net.ssl.HttpsURLConnection;

public class FileServerTransactions {
	//Timouts
	protected static final int CONNECTION_TIMEOUT = 10000;
	protected static final int SOCKET_TIMEOUT = 0; //30000?

	private final String USER_AGENT = "Mozilla/5.0";

	static InputStream is = null;

	public FileServerTransactions(){

	}

	// HTTP GET request ListRessources This function runs right
	public String listResources(String token, ArrayList<String> types) throws Exception {

		String url = "https://ri.smarttracker.no/files/resource.php?type=image";
		
		for(int i=0;i<types.size();i++){
			if(i==0)
				url = url+"?type="+types.get(i);
			else
				url=url+"&type="+types.get(i);
		}
		
		URL obj = new URL(url);
		HttpsURLConnection con = (HttpsURLConnection) obj.openConnection();

		// optional default is GET
		con.setRequestMethod("GET");
		con.setDoInput(true);


		//add request header
		//con.setRequestProperty("User-Agent", USER_AGENT);
		con.setRequestProperty("X-Auth-Token",token);
		
		con.connect();
		

		int responseCode = con.getResponseCode();
		System.out.println("\nSending 'GET' request to URL : " + url);
		System.out.println("Response Code : " + responseCode);

		BufferedReader in = new BufferedReader(
		        new InputStreamReader(con.getInputStream()));
		String inputLine;
		StringBuffer response = new StringBuffer();

		while ((inputLine = in.readLine()) != null) {
			response.append(inputLine);
		}
		in.close();

		//print result
		System.out.println(response.toString());

		return response.toString();

	}

	// HTTP GET request FetchRessources OK Output Picture not nice but OK
	public Bitmap fetchResources(String resID, String token) throws Exception {

		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		Bitmap bmp = null;
		String url = "https://ri.smarttracker.no/files/resource.php?resourceID=" + resID;
		try{

		URL obj = new URL(url);
		HttpsURLConnection con = (HttpsURLConnection) obj.openConnection();

		// optional default is GET
		con.setRequestMethod("GET");
		con.setDoInput(true);
		con.setDoOutput(false);
		con.setUseCaches(false);
		con.setAllowUserInteraction(false);
		con.setConnectTimeout(CONNECTION_TIMEOUT);
		con.setReadTimeout(SOCKET_TIMEOUT);
		//Set Token
		con.setRequestProperty("X-Auth-Token", token);
		con.setRequestProperty("Connection", "Keep-Alive");

		con.connect();
		//
		int statusCode = con.getResponseCode();

			//Inputstream to String
		InputStream is = con.getInputStream();

			bmp = BitmapFactory.decodeStream(is);
/*
			BufferedReader br = null;
			StringBuilder sb = new StringBuilder();

			String line;
			try {

				br = new BufferedReader(new InputStreamReader(is));
				while ((line = br.readLine()) != null) {
					sb.append(line);
				}

			} catch (IOException e) {
				e.printStackTrace();
			} finally {
				if (br != null) {
					try {
						br.close();
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
			}

			System.out.println("InputStream:"+sb.toString());

		/*

		byte[] b = new byte[1024];

		while ( is.read(b) != -1)
			baos.write(b);
*/
			con.disconnect();

			int responseCode = con.getResponseCode();
			System.out.println("\nSending 'GET' request to URL : " + url);
			System.out.println("Response Code : " + responseCode);
			//Get Filename
			String filename=con.getHeaderField("Content-Disposition").substring(22);
			filename=filename.substring(0,filename.length()-1);
			System.out.println("Request Property(filename):"+filename);
			//TODO Save file internal
		}
		catch(Throwable t) {
			t.printStackTrace();
		}

		//return "Response Code: "+responseCode;
		return bmp;
	}

	//HTTP Get request deleteFile
	public JSONObject deleteResource(String resID, String token) throws Exception{

		String url = "https://ri.smarttracker.no/files/resource.php"+"?resourceID="+resID;

		URL obj = new URL(url);
		HttpsURLConnection con = (HttpsURLConnection) obj.openConnection();

		// optional default is GET
		con.setRequestMethod("DELETE");
		con.setDoInput(true);

		//add request header
		//con.setRequestProperty("User-Agent", USER_AGENT);
		con.setRequestProperty("X-Auth-Token",token);

		con.connect();

		int responseCode = con.getResponseCode();
		System.out.println("\nSending 'GET' request to URL : " + url);
		System.out.println("Response Code : " + responseCode);

		BufferedReader in = new BufferedReader(
				new InputStreamReader(con.getInputStream()));
		String inputLine;
		StringBuffer response = new StringBuffer();

		while ((inputLine = in.readLine()) != null) {
			response.append(inputLine);
		}
		in.close();

		//print result
		System.out.println(response.toString());

		JSONObject jobj = new JSONObject(response.toString());
		return jobj;

	}


	// HTTP POST request Auth on Server
	//This functions runs right
	public String authOnFileServer(String myURL, String userName, String password) throws Exception {

		//String url = "https://ri.smarttracker.no/files/login.php";
		URL obj = new URL(myURL);
		HttpsURLConnection con = (HttpsURLConnection) obj.openConnection();

		//add reuqest header
		con.setRequestMethod("POST");
		con.setRequestProperty("Content-Type","application/json");

		String urlParameters = "{”username”:”"+userName+"”,”password”:”"+password+"”}";

		// Send post request
		con.setDoOutput(true);
		DataOutputStream wr = new DataOutputStream(con.getOutputStream());
		wr.writeBytes(urlParameters);
		wr.flush();
		wr.close();

		int responseCode = con.getResponseCode();
		System.out.println("\nSending 'POST' request to URL : " + myURL);
		System.out.println("Post parameters : " + urlParameters);
		System.out.println("Response Code : " + responseCode);

		BufferedReader in = new BufferedReader(
		        new InputStreamReader(con.getInputStream()));
		String inputLine;
		StringBuffer response = new StringBuffer();

		while ((inputLine = in.readLine()) != null) {
			response.append(inputLine);
		}
		in.close();

		//print result
		System.out.println(response.toString());
		System.out.println(response.substring(10, response.length()-2));
		
		return response.toString();

	}


	// HTTP POST request AddRessource
	//This function is not correct
	public JSONObject addResource(String url, String token, File file) throws Exception {

		//Create File Ressource
			URL obj = new URL(url);
			HttpURLConnection urlc = (HttpURLConnection) obj.openConnection();
			urlc.setRequestMethod("POST");
			urlc.setDoOutput(true);
			urlc.setDoInput(true);
			urlc.setUseCaches(false);
			urlc.setAllowUserInteraction(false);
			urlc.setConnectTimeout(CONNECTION_TIMEOUT);
			urlc.setReadTimeout(SOCKET_TIMEOUT);
			urlc.setRequestProperty("X-Auth-Token", token);
			urlc.setRequestProperty("Content-type", "application/x-www-form-urlencoded");

			OutputStreamWriter osw = new OutputStreamWriter(urlc.getOutputStream());
			osw.write("type=");
			osw.write("testimg");
			osw.write("&filename=");
			osw.write("saft");

			osw.flush();
			int respCode = urlc.getResponseCode();
			osw.close();

			System.out.println("ResponseCode:"+respCode);

			StringBuilder sb = new StringBuilder();
			InputStreamReader isr = null;
			try {
				isr = new InputStreamReader(urlc.getInputStream());
			} catch (IOException e) {
				isr = null;
			}
			if (isr != null) {
				int len;
				char[] chr = new char[1024];
				while ((len = isr.read(chr)) > 0) {
					sb.append(chr, 0, len);
				}
			}
			urlc.disconnect();

			//Get resource ID:
			//----------------
			//If respCode is 2xx, the response string should be a JSON with the resource ID.

			JSONObject json = new JSONObject(sb.toString());
			String msg = json.optString("message"); //For logging
			String resourceID = json.optString("resourceID");

			System.out.println("Message: "+msg);

			return json;
		}

	public void uploadFile(String url,String token,String resID, File file)throws Exception{
		//Here the URL is as above (resource or resource2 .php), but adding "?resourceID=" and the resource ID.

		String myURL = url+"?resourceID="+resID;
		URL obj = new URL(myURL);
		HttpURLConnection urlc = (HttpURLConnection) obj.openConnection();
		urlc.setRequestMethod("POST");
		urlc.setDoOutput(true);
		urlc.setDoInput(false);
		urlc.setUseCaches(false);
		urlc.setAllowUserInteraction(false);
		urlc.setConnectTimeout(CONNECTION_TIMEOUT);
		urlc.setReadTimeout(SOCKET_TIMEOUT);
		urlc.setRequestProperty("Connection", "Keep-Alive");
		urlc.setRequestProperty("X-Auth-Token", token);

		FileInputStream in = new FileInputStream(file);
		OutputStream out = urlc.getOutputStream();
		byte[] buffer = new byte[1024];
		int length;
		while ((length = in.read(buffer))>0) {
			out.write(buffer, 0, length);
		}
		out.flush();
		int respCode = urlc.getResponseCode();
		out.close();
		in.close();

		urlc.disconnect();

		System.out.println("ResponseCode UploadFile:"+respCode);
	}


	//HTTP POST request ChangeRessource
	//public String ChangeRessource(String token,File file, String type,String resID,string assetID) throws Exception

	//Convert my file to a Base64 String
	private String convertFileToString(File file) throws IOException{
		FileInputStream fileInputStream = null;
		byte[] bFile = new byte[(int) file.length()];
		try
		{
			//convert file into array of bytes
			fileInputStream = new FileInputStream(file);
			fileInputStream.read(bFile);
			fileInputStream.close();
			for (int i = 0; i < bFile.length; i++)
			{
				System.out.print((char) bFile[i]);
			}
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}

		return new String(bFile);
	}
}
