package com.example.pschmitt.starterapp;

/**
 * Created by pschmitt on 15.08.2016.
 */

import android.os.Environment;
import android.util.Log;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.URL;




public class JSONParser {

    static InputStream is = null;
    static JSONObject jObj = null;
    static String json = "";
    static final String EXT_PATH_BASE = "/Android/data/";
    static final String PACKAGE_NAME = "no.tellu.poseidon";

    // constructor
    public JSONParser() {

    }

    //Convert String to JSON-Object
    public JSONObject stringToJSONObject (String text){
        JSONObject jsonObj = null;

        try {

            Log.d("JSON Object true:","");
            jsonObj = new JSONObject(text);

        } catch (JSONException e) {
            Log.e("JSON Parser", "Error parsing data " + e.toString());
        }

        return jsonObj;
    }


    public JSONObject authOnFileServer(String url, String userName, String password){

        try{
            //String url = "https://ri.smarttracker.no/files/login.php";
            URL obj = new URL(url);
            HttpURLConnection con = (HttpURLConnection) obj.openConnection();

            //add reuqest header
            con.setRequestMethod("POST");
            con.setRequestProperty("Content-Type","application/json");

            String urlParameters = "{”username”:”"+userName+"”,”password”:”"+password+"”}";

            // Send post request
            con.setDoOutput(true);
            DataOutputStream wr = new DataOutputStream(con.getOutputStream());
            wr.writeBytes(urlParameters);
            wr.flush();
            wr.close();


            try {
                int responseCode = con.getResponseCode();
                System.out.println("\nSending 'POST' request to URL : " + url);
                System.out.println("Post parameters : " + urlParameters);
                System.out.println("Response Code : " + responseCode);


                BufferedReader in = new BufferedReader(
                        new InputStreamReader(con.getInputStream()));
                String inputLine;
                StringBuffer response = new StringBuffer();

                while ((inputLine = in.readLine()) != null) {
                    response.append(inputLine);
                }
                in.close();

                json = response.toString();
                Log.d("JSON String:",json);
                //print result
                System.out.println(response.toString());
            } catch (Exception e) {
                Log.e("Buffer Error", "Error converting result " + e.toString());
            }


        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }


        // try parse the string to a JSON object
        try {

            Log.d("JSON Object true:","");
            jObj = new JSONObject(json);

        } catch (JSONException e) {
            Log.e("JSON Parser", "Error parsing data " + e.toString());
        }


        // return JSON String
        return jObj;


    }

    public JSONObject getJSONFromUrl(String myurl, String mytoken) throws JSONException {

        // Making HTTP request
        try {
            URL url = new URL(myurl);
            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            conn.setReadTimeout(10000 /* milliseconds */);
            conn.setConnectTimeout(15000 /* milliseconds */);
            conn.setRequestMethod("GET");
            conn.setDoInput(true);
            conn.setRequestProperty("X-Auth-Token",mytoken);
            conn.connect();
            int response = conn.getResponseCode();
            Log.d("CONN:-", "The response is: " + response);
            is = conn.getInputStream();

        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }

        try {
            BufferedReader reader = new BufferedReader(new InputStreamReader(
                    is, "iso-8859-1"), 8);
            StringBuilder sb = new StringBuilder();
            String line = null;
            while ((line = reader.readLine()) != null) {
                sb.append(line + "n");
            }
            is.close();
            json = sb.toString();
            Log.d("JSON String:",json);
        } catch (Exception e) {
            Log.e("Buffer Error", "Error converting result " + e.toString());
        }

        // try parse the string to a JSON object
        try {

            Log.d("JSON Object true:","");
            jObj = new JSONObject(json);

        } catch (JSONException e) {
            Log.e("JSON Parser", "Error parsing data " + e.toString());
        }


        // return JSON String
        return jObj;

    }

    public JSONObject getJSONArrayFromUrl(String myurl, String mytoken) throws JSONException {

        // Making HTTP request
        try {
            Log.d("URL: ", myurl);
            URL url = new URL(myurl);
            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            conn.setReadTimeout(10000 /* milliseconds */);
            conn.setConnectTimeout(15000 /* milliseconds */);
            conn.setRequestMethod("GET");
            conn.setDoInput(true);
            conn.setRequestProperty("X-Auth-Token",mytoken);
            conn.connect();
            int response = conn.getResponseCode();
            Log.d("CONN:-", "The response is: " + response);
            is = conn.getInputStream();

        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }

        try {
            BufferedReader reader = new BufferedReader(new InputStreamReader(
                    is, "iso-8859-1"), 8);
            StringBuilder sb = new StringBuilder();
            String line = null;
            while ((line = reader.readLine()) != null) {
                sb.append(line + "n");
            }
            is.close();
            json = sb.toString();
            Log.d("JSON String:",json);
        } catch (Exception e) {
            Log.e("Buffer Error", "Error converting result " + e.toString());
        }

        // try parse the string to a JSON object
        try {

            Log.d("JSON Array true:","");
            JSONArray jArr = new JSONArray(json);
            Log.d("Array created,:"," extracting Obj");
            jObj = jArr.getJSONObject(0);

        } catch (JSONException e) {
            Log.e("JSON Parser", "Error parsing data " + e.toString());
        }


        // return JSON String
        return jObj;

    }

    public void getImageFromUrl(String myurl, String mytoken, String filename) {

        // Making HTTP request
        try {
            URL url = new URL(myurl);
            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            conn.setReadTimeout(10000 /* milliseconds */);
            conn.setConnectTimeout(15000 /* milliseconds */);
            conn.setRequestMethod("GET");
            conn.setDoInput(true);
            conn.setRequestProperty("X-Auth-Token", mytoken);
            conn.connect();
            int response = conn.getResponseCode();
            Log.d("CONN:-", "The response is: " + response);
            is = conn.getInputStream();

        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }

        try {
            BufferedReader reader = new BufferedReader(new InputStreamReader(
                    is, "iso-8859-1"), 8);
            StringBuilder sb = new StringBuilder();
            String line = null;
            while ((line = reader.readLine()) != null) {
                sb.append(line + "n");
            }
            is.close();
            json = sb.toString();
            Log.d("---- IMAGE String:", json);
        } catch (Exception e) {
            Log.e("Buffer Error", "Error converting result " + e.toString());
        }



        if (isExternalStorageWritable()){
            File rt = Environment.getExternalStorageDirectory();
            String store_images_path = rt.getAbsolutePath() + EXT_PATH_BASE + PACKAGE_NAME + "/files/media";

            File file_image = new File(store_images_path,filename);
            try {

                FileOutputStream fileOutputStream = new FileOutputStream(file_image);

            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }
    }

    /* Checks if external storage is available for read and write */
    public boolean isExternalStorageWritable() {
        String state = Environment.getExternalStorageState();
        if (Environment.MEDIA_MOUNTED.equals(state)) {
            return true;
        }
        return false;
    }

}



