package com.example.pschmitt.starterapp;

import android.content.Intent;
import android.os.StrictMode;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import no.tellu.findit.client.api.AsyncService;

public class LoginActivity extends AppCompatActivity implements View.OnClickListener {
    Button btnLogin;

    EditText emailText, passwordText;

    TextView textview;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_login);

        //Nicht schön aber geht
        StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();

        StrictMode.setThreadPolicy(policy);

        emailText = (EditText) findViewById(R.id.emailfield);
        passwordText = (EditText) findViewById(R.id.passwordfield);

        btnLogin = (Button) findViewById(R.id.btnLogin);
		btnLogin.setEnabled(true);
		btnLogin.setOnClickListener(this);

        textview = (TextView) findViewById(R.id.loginState);
    }

	@Override
	public void onClick(View v) {
		btnLogin.setEnabled(false);
		textview.setText("Logging in...");
		AsyncService.AccountCallback callback = new AsyncService.AccountCallback() {
			@Override
			public void onAccountOK(long customerId, String customer) {
				Intent nextScreen = new Intent(LoginActivity.this, ActionChoosingActivity.class);
				startActivity(nextScreen);
				finish();
			}

			@Override
			public void onAccountError(int code, String message, Exception e) {
				emailText.setBackgroundColor(getResources().getColor(R.color.Poseidon_Red));
				passwordText.setBackgroundColor(getResources().getColor(R.color.Poseidon_Red));
				emailText.setText(null);
				passwordText.setText(null);
				btnLogin.setEnabled(true);
				textview.setText("Login error");
			}
		};

		StarterApp app = (StarterApp)getApplication();
		app.login(emailText.getText().toString(), passwordText.getText().toString(), callback);
	}
}

