package com.example.pschmitt.starterapp;


import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.widget.TextView;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.Map;

import no.tellu.findit.client.api.AsyncService;
import no.tellu.findit.client.edge.AsyncEdgePoster;
import no.tellu.findit.client.edge.Observation;
import no.tellu.findit.client.edge.ObservationPoster;

/**
 * Demonstrates how to post an observation to the SmartPlatform server.
 */
public class ObservationActivity extends AppCompatActivity
		implements AsyncService.TransactionCallback, ObservationPoster.PostCallback {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_observation);

		//First we need to get the device UUID from the device of the asset
		StarterApp app = (StarterApp)getApplication();
		app.getDevice(this);
	}

	@Override
	public void onTransactionOK(JSONObject object) {
		TextView textView = (TextView) findViewById(R.id.textView);
		try {
			textView.append("Retrieved device " + object.getString("name"));
			textView.append("\n");
			String uuid = object.getString("uuid");
			AsyncEdgePoster edgePoster = new AsyncEdgePoster(StarterApp.EDGE_URL, uuid);

			//Create a test observation to post
			Observation obs = new Observation();
			obs.setPropertyAsString("testProp1", "1");
			obs.setPropertyAsString("testProp2", "something");
			edgePoster.doPostAsync(obs, this);

		} catch (JSONException e) {
			Log.e("StarterApp", "JSON error", e);
		}
	}

	@Override
	public void onTransactionError(int i, String s, Exception e) {
		TextView textView = (TextView) findViewById(R.id.textView);
		textView.append("Error retrieving device");
		textView.append(s);
	}

	@Override
	public void onPostOK(int i, Map<String, String> map) {
		TextView textView = (TextView) findViewById(R.id.textView);
		textView.append("Observation posted OK");
	}

	@Override
	public void onPostError(int i, Exception e) {
		TextView textView = (TextView) findViewById(R.id.textView);
		textView.append("Observation post ERROR: " + i);
	}
}
